#include "s_tools.h"
#include "pins.h"  // jar, alle Pin #define und Belegungen

char c_str[20];
char r_str[20];

// prog_char string_0[] PROGMEM = "String 0";   // "String 0" etc are strings to store - change to suit.
prog_char mo0[] PROGMEM = "   "; prog_char mo1[] PROGMEM = "Jan"; prog_char mo2[] PROGMEM = "Feb"; 
prog_char mo3[] PROGMEM = "Mar"; prog_char mo4[] PROGMEM = "Apr"; prog_char mo5[] PROGMEM = "May"; 
prog_char mo6[] PROGMEM = "Jun"; prog_char mo7[] PROGMEM = "Jul"; prog_char mo8[] PROGMEM = "Aug"; 
prog_char mo9[] PROGMEM = "Sep"; prog_char mo10[] PROGMEM = "Oct"; prog_char mo11[] PROGMEM = "Nov";
prog_char mo12[] PROGMEM = "Dec";

// Then set up a table to refer to your strings.
PROGMEM const char *mo_table[] = 	   // change "string_table" name to suit
{ mo0, mo1, mo2, mo3, mo4, mo5, mo6, mo7, mo8, mo9, mo10, mo11, mo12 };


#ifdef MY_DCF77_IN
  uint8_t bcd2int( uint8_t bcd )
  { return ((uint8_t)(((bcd>>4)*10)+(bcd&15)));
  }
  uint8_t int2bcd( uint8_t integer )
  { return ((uint8_t)(((integer/10)<<4)+(integer%10)));
  }
#endif


uint8_t led_test_flags=0;
uint8_t i2c_test_flags=0;
uint8_t _i2c_busy=0;

/*
#define I2C_TASTATUR_8574    0
#define I2C_TASTATUR_8574A   1
#define I2C_OLED             2
#define I2C_RTC_1307         3
#define I2C_RTC_3231         4
#define I2C_RTC_TEMP_BSY     5
#define I2C_RTC_TEMP_RD_SET  6
#define I2C_EEPROM           7
*/

char *lefts( char *str1, unsigned char num1 )
{ static char copy1[MAX_STRING];
  char bak1[MAX_STRING];

  strcpy(bak1, str1);
  if( num1<32 && num1<=strlen(bak1) )
  { strncpy(copy1, bak1, num1 );
    *(copy1+num1)=0;
  } // if( num1<32 && num1<=strlen(bak1) )
  return copy1;
} // char *lefts( char *str1, unsigned char num1 )

char *rights( char *str2, unsigned char num2 )
{ static char copy2[MAX_STRING];
  char bak2[MAX_STRING];

  strcpy(bak2, str2);
  if( num2<32 && num2<=strlen(bak2) && strlen(bak2)<32 )
    strcpy(copy2,  (str2+strlen(bak2)-num2) );
  return copy2;
} // char *rights( char *str2, unsigned char num2 )

char *mids( char *str3, unsigned char num3, unsigned char num4 )
{ static char copy3[MAX_STRING];
  char bak3[MAX_STRING];

  strcpy(bak3, str3);
  if( num3<32 && num3<=strlen(bak3) && num4<32 && num4<strlen(bak3) && (num3+num4-1)<=strlen(bak3) && strlen(bak3)<32 )
    strncpy(copy3,  (bak3+num3-1), num4 );
  return copy3;
} // char *mids( char *str3, unsigned char num3, unsigned char num4 )
/*
char *trimm_string(char vorlauf, char *s_string, uint8_t num)
{ static char _tmp[MAX_STRING]={0};
  memset( _tmp, (int)vorlauf, num);
  _tmp[num]=0;
  strcat(_tmp, s_string);
  return &_tmp[strlen(_tmp)-num];
} // char *trimm_string(char vorlauf, char *s_string, uint8_t num)

char *insert_char(char *s_string, char ins, uint8_t wo)
{ static char _tmp[MAX_STRING]={0};
  strncpy(_tmp, s_string, wo);
  _tmp[wo]=ins;
  _tmp[wo+1]=0;
  strcat(_tmp,  (s_string+wo));
  //__tmp[3]=0; // nur noch eine Nachkommastelle
  return _tmp;
} // char *insert_char(char *s_string, char ins, uint8_t wo)
*/
/*
char *trimm_all( uint8_t _KO, uint8_t _LE, uint8_t lo ) 
{ static char _tmp[MAX_STRING]={0};
  char s_LC_DIS8[9]={0}, s_tmp[4]={0};
  strcpy(s_LC_DIS8, trimm_string('0', itoa(_KO, s_tmp, 10), lo));
  strcat(s_LC_DIS8, "/");
  strcat(s_LC_DIS8, trimm_string('0', itoa(_LE, s_tmp, 10), lo));
  strcpy(_tmp, s_LC_DIS8);
  return _tmp;
} // char *trimm_all( uint8_t _KO, uint8_t _LE, uint8_t lo ) 
*/

// -------------- Compile -------------------------------------
unsigned char compile_time(void)
{ uint8_t cc, jj=0, mo=0, ta=0, hh=0, mm=0, ss=0;
  uint16_t jjjj=0, tn=0;
  char buffer_l[15];
  char buffer[4];

  strcpy(buffer_l, __DATE__);
  jjjj=atoi(rights(buffer_l, (uint8_t)4));
  jj=atoi(rights(buffer_l, (uint8_t)2));
  ta=atoi(mids(buffer_l, (uint8_t)5, (uint8_t)2));
  for(cc=1; cc<13; cc++)
  { strcpy_P(buffer, (char*)pgm_read_word(&(mo_table[cc]))); // Necessary casts and dereferencing, just copy. 
    if(!strcmp((char *)lefts(buffer_l, (uint8_t)3), (char *)buffer))
    { mo=cc; break; }
  } // for(cc=1; cc<13; cc++)
  strcpy(buffer_l, __TIME__);
  hh=atoi((char *)lefts(buffer_l, 2));
  mm=atoi((char *)mids(buffer_l, 4, 2));
  ss=atoi((char *)rights(buffer_l, 2));

  sprintf((char *)c_str,"%04d/%02d/%02d_%02d:%02d:%02d", jjjj, mo, ta, hh, mm, ss);
  if(jjjj>0 && jj>0 && mo>0 && ta>0 && hh>0 && mm>0 && ss>0 && tn>0)
    return (uint8_t)1;
  else
    return (uint8_t)0;
} // unsigned char compile_time(void)


unsigned char mesz_var;
// -------------- calen ---------------------------------------
//---- Algorithmen ----
//
//   Eingabe: Jahr
//   Ausgabe: 0 kein Schaltjahr       1 Schaltjahr
//
/*
uint8_t schaltjahr( uint16_t jahr )
{ if(  ((jahr % 4 == 0) 
    && (jahr % 100 != 0)) 
    || (jahr % 400 == 0) )
      return (uint8_t)1;
  return (uint8_t)0;
}
*/
// kurzform
uint8_t schaltjahr( uint16_t jahr )
{ if(  (jahr % 4 == 0) )
    return (uint8_t)1;
  return (uint8_t)0;
} // uint8_t schaltjahr( uint16_t jahr )

//
//	Eingabe: Jahr
//				Tagesnummer rel. zum Jahresanfang
//				(1=1.1.,2=2.1.,...365/366=31.12)
//	Ausgabe: Monat (1=Jan, 2=Feb, ... 12 = Dec)
//	Algorithmus von R. A. Stone
//
uint8_t monat_im_jahr(uint16_t jahr, uint16_t n)
{ uint8_t a;
  a = schaltjahr(jahr);
  if ( (int16_t)n > 59+a )
    n += 2-a;
  n += 91;
  return (uint8_t)((20*n)/611 - 2);
} // uint8_t monat_im_jahr(uint16_t jahr, uint16_t n)

//
//	Eingabe: Jahr
//				Tagesnummer rel. zum Jahresanfang
//				(1=1.1.,2=2.1.,...365/366=31.12)
//	Ausgabe: Tag (1..31)
//	Algorithmus von R. A. Stone
//
uint8_t tag_im_monat(uint16_t jahr, uint16_t n)
{ uint8_t	a;
  int16_t m;
  a = schaltjahr(jahr);
  if ( (int16_t)n > 59+a )
    n += 2-a;
  n += 91;
  m = (20*n)/611;
  return (uint8_t)(n - (611*m)/20);
} // uint8_t tag_im_monat(uint16_t jahr, uint16_t n)

//
//   Eingabe: Jahr
//            Monat (1=Jan, 2=Feb, ... 12 = Dec)
//            Tag   (1...31)
//   Ausgabe: Tagesnummer rel. zum Jahresanfang
//            (1=1.1.,2=2.1.,...365/366=31.12)
//   Algorithmus von Robertson
//
uint16_t tagesnummer( uint16_t jahr, uint8_t monat, uint8_t tag )
{ int d, e;
  d= (monat+10)/13;
  e= tag+ (611*(monat+2))/20 - 2*d - 91;
  return e + schaltjahr(jahr)*d;
} // uint16_t tagesnummer( uint16_t jahr, uint8_t monat, uint8_t tag )


//
//	Eingabe:  Jahr, Tagesnummer
//	Ausgabe:  Wochentag (1=Mo,..., 6=Sa, 7=So)
//
uint8_t wochentag_im_jahr(uint16_t jahr, uint16_t n)
{ int j,c; uint8_t _wt_;
  j = (jahr-1) % 100;
  c = (jahr-1) / 100;
  _wt_=(uint8_t)((28+j+n+(j/4)+(c/4)+5*c) % 7);
  if(!_wt_)			//case 0: //	C'T // 7 dcf77 + rtc
    _wt_=7;
  return _wt_;
} // uint8_t wochentag_im_jahr(uint16_t jahr, uint16_t n)

char *strWochentagname( uint8_t TagNummer )
{ switch (TagNummer)
  { case 1:
      return"Montag    ";
    case 2:
      return"Dienstag  ";
    case 3:
      return"Mittwoch  ";
    case 4:
      return"Donnerstag";
    case 5:
      return"Freitag   ";
    case 6:
      return"Samstag   ";
    case 7: //	RTC
      //case 0: //	C'T
      return"Sonntag   ";
    default: 
      return"ERROR     ";
  } // switch (TagNummer)
} // char *strWochentagname( uint8_t TagNummer )

//wochentag_im_jahr(uint16_t jahr, uint16_t n)
char *strWochentagname_kurz( uint8_t TagNummer )
{ switch (TagNummer)
  { case 1:
      return"Mo";
    case 2:
      return"Di";
    case 3:
      return"Mi";
    case 4:
      return"Do";
    case 5:
      return"Fr";
    case 6:
      return"Sa";
    case 7: //	RTC // dcf77
      //case 0: //	C'T
      return"So";
    default: 
      return"ER";
	} // switch (TagNummer)
} // char *strWochentagname_kurz( uint8_t TagNummer )


char* strMonatsname( uint8_t Monat )
{ switch (Monat)
  { case 1:
      return"Januar";
    case 2:
      return"Februar";
    case 3:
      return"Maerz";
    case 4:
      return"April";
    case 5:
      return"Mai";
    case 6:
      return"Juni";
    case 7:
      return"Juli";
    case 8:
      return"August";
    case 9:
      return"September";
    case 10:
      return"Oktober";
    case 11:
      return"November";
    case 12:
      return"Dezember";
    default:
      return"ERROR";
  } // switch (Monat)
} // char* strMonatsname( uint8_t Monat )

char* strMonatsname_kurz( uint8_t Monat )
{ switch (Monat)
  { case 1:
      return"Jan";
    case 2:
      return"Feb";
    case 3:
      return"Mae";
    case 4:
      return"Apr";
    case 5:
      return"Mai";
    case 6:
      return"Jun";
    case 7:
      return"Jul";
    case 8:
      return"Aug";
    case 9:
      return"Sep";
    case 10:
      return"Okt";
    case 11:
      return"Nov";
    case 12:
      return"Dez";
    default:
      return"ERR";
  }
}

/*
//
//	Eingabe: Jahr
//	Ausgabe: Tagesnummer des Ostersonntag,
//				rel. zum Jahresanfang.
//	Algorithmus "Computus ecclesiasticus"
//
//	325 n.Chr. wurde Ostern auf den Sonntag nach
//	dem ersten Fruehlingsvollmond festgelegt. Damit
//	liegt Ostern zwischen dem 22. Maerz und
//	dem 25. April.
//
int16_t ostersonntag(uint16_t jahr)
{ int16_t gz, jhd, ksj, korr, so, epakte, n;
  gz = (jahr%19)+1;
  jhd = jahr/100+1;
  ksj = (3*jhd)/4-12;
  korr = (8*jhd+5)/25-5;
  so = (5*jahr)/4-ksj-10;
  epakte = (11*gz+20+korr-ksj) % 30;
  if ( (epakte == 25 && gz > 11) || epakte == 24 )
    epakte++;
  n = 44-epakte;
  if ( n < 21 )
    n = n + 30;
  n = n + 7 - (so+n) % 7;
  n += schaltjahr(jahr);
  return n+59;
} // int16_t ostersonntag(uint16_t jahr)
*/

//
//	Eingabe: Jahr, Monat
//	Ausgabe: Monatstage
//
uint8_t Monatstage( uint16_t jahr, uint8_t Monat )
{ switch ((int)Monat)
  { case 1:
      return 31;
    case 2:
      return (uint8_t)(28 + schaltjahr(jahr));
    case 3:
      return 31;
    case 4:
      return 30;
    case 5:
      return 31;
    case 6:
      return 30;
    case 7:
      return 31;
    case 8:
      return 31;
    case 9:
      return 30;
    case 10:
      return 31;
    case 11:
      return 30;
    case 12:
      return 31;
    default:
      return 0;
  } // switch ((int)Monat)
} // uint8_t Monatstage( uint16_t jahr, uint8_t Monat )


// Eingabe: Jahr, Tagesnummer, Hour
//	Ausgabe: MESZ 1:0
uint8_t mesz( uint16_t jahr, uint16_t tij, uint8_t hour )
{ unsigned char beginnMESZ = tagesnummer( jahr, 3, 31 );
  unsigned endeMESZ = tagesnummer( jahr, 10, 31 );
  uint8_t mo;

  mo=monat_im_jahr(jahr, tij);

  if(mo > 2 && mo < 11)				// 11, 12, 1 und 2 haben keine Sommerzeit
  { // auf Sommerzeit korrigieren
    while(wochentag_im_jahr(jahr, beginnMESZ) != 7)
      beginnMESZ--;
    while(wochentag_im_jahr(jahr, endeMESZ) != 7)
      endeMESZ--;

    if( tij>beginnMESZ && tij<endeMESZ )
      return (uint8_t)1;
    else
    { if( tij==beginnMESZ && hour>=2  )
        return (uint8_t)1;
      if( tij==endeMESZ && hour<3  )
        return (uint8_t)1;
    }
  } // if(mo > 2 && mo < 11)
  return (uint8_t)0;
} // uint8_t mesz( uint16_t jahr )



