#ifndef S_TOOLS_H
#define S_TOOLS_H	

//#define DEBUG
#ifdef DEBUG
#define DEBUG_PRINT(x)              Serial.print(x)
#define DEBUG_PRINT_DEC_HEX(x, y)   Serial.print(x, y)
#define DEBUG_PRINTLN(x)            Serial.println(x)
#define DEBUG_PRINTLN_DEC_HEX(x, y) Serial.println(x, y)
#else
#define DEBUG_PRINT(x)
#define DEBUG_PRINT_DEC_HEX(x, y)
#define DEBUG_PRINTLN(x)
#define DEBUG_PRINTLN_DEC_HEX(x, y)
#endif 

extern char c_str[20];
extern char r_str[20];

extern uint8_t i2c_test_flags;
extern uint8_t _i2c_busy;

#define I2C_TASTATUR_8574    0
#define I2C_TASTATUR_8574A   1
#define I2C_OLED             2
#define I2C_RTC_1307         3
#define I2C_RTC_3231         4
#define I2C_RTC_TEMP_BSY     5
#define I2C_RTC_TEMP_RD_SET  6
#define I2C_EEPROM           7


extern uint8_t led_test_flags;
// LED bit
#define LED_ON                 0
#define AUTO_LDR               1
#define AUTO_COLOR             2
#define LED_NEXT               3

#define MAX_STRING 41

#ifndef FALSE
	#define FALSE NULL
	#define TRUE !FALSE
#endif

void eeprom_clr(void);
uint16_t eeprom_size(void);
//void lcd_eeprom_string(uint16_t);

extern char *ausgabe_str(unsigned long);
extern char *my_i2a_5(uint16_t);
extern char *lefts( char *, uint8_t );
extern char *rights( char *, uint8_t );
extern char *mids( char *, uint8_t, uint8_t );
extern char *int2bin5(uint8_t);
//extern char *trimm_string(char vorlauf, char *s_string, uint8_t);
//extern char *insert_char(char *s_string, char ins, uint8_t);
extern uint8_t compile_time(void);
//extern uint32_t ntohl(uint32_t);
extern char* strMonatsname( uint8_t );
extern uint8_t Monatstage( uint16_t, uint8_t );
/* // nicht fÃ¼r Arduino
uint8_t bcdtoint( uint8_t );
uint8_t int2bcd( uint8_t );
*/


#endif // #ifndef S_TOOLS_H






